Summary:        Safely and cleanly create closures via string eval
Name:           perl-Eval-Closure
Version:        0.14
Release:        5%{?dist}
License:        GPL+ or Artistic
URL:            https://metacpan.org/release/Eval-Closure
Source0:        https://cpan.metacpan.org/authors/id/D/DO/DOY/Eval-Closure-%{version}.tar.gz

BuildRequires:  coreutils findutils make perl-interpreter
BuildRequires:  perl(ExtUtils::MakeMaker) perl-generators
BuildRequires:  perl(Carp) perl(constant) perl(Exporter)  
BuildRequires:  perl(Devel::LexAlias) >= 0.05 perl(overload) 
BuildRequires:  perl(Perl::Tidy) perl(Scalar::Util) perl(strict)
BuildRequires:  perl(B) perl(blib) perl(File::Spec) 
BuildRequires:  perl(IPC::Open3) perl(IO::Handle) perl(PadWalker) 
BuildRequires:  perl(Test::Fatal) perl(Test::Requires)
BuildRequires:  perl(warnings) perl(Test::More) >= 0.88
Requires:       perl(Devel::LexAlias) >= 0.05 perl(Perl::Tidy)      

BuildArch:      noarch

%description
String eval is often used for dynamic code generation. For instance, Moose uses 
it heavily, to generate inlined versions of accessors and constructors, which 
speeds code up at runtime by a significant amount. String eval is not without 
its issues however - it's difficult to control the scope it's used in (which 
determines which variables are in scope inside the eval), and it's easy to miss 
compilation errors, since eval catches them and sticks them in $@ instead. This 
module attempts to solve these problems. It provides an eval_closure function, 
which evals a string in a clean environment, other than a fixed list of specified 
variables. Compilation errors are rethrown automatically.

%prep
%autosetup -n Eval-Closure-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%make_build

%install
%make_install
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license LICENSE
%doc Changes README
%{perl_vendorlib}/Eval/
%{_mandir}/man3/Eval::Closure.3*

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.14-5
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Aug 15 2023 Xiaojie Chen <jackxjchen@tencent.com> - 0.14-4
- Remove perl(:MODULE_COMPAT) which will be generated by perl-generators >= 1.15

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.14-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.14-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Aug 17 2022 Wang Zhe <bessiewang@tencent.com> - 0.14-1
- initial build
